/////////////////////////////////////////////////////////////////////////////
// Name:        BurnHelpers.h
// Author:      XX
// Created:     XX/XX/XX
// Copyright:   XX
/////////////////////////////////////////////////////////////////////////////

#ifndef __BurnHelpers_H__
#define __BurnHelpers_H__

#ifdef __GNUG__
    #pragma interface "BurnHelpers.cpp"
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

#include "wxBurn_wdr.h"

#include <wx/hashmap.h>
#include <map>

// WDR: class declarations
namespace BurnHelpers
{

  struct DeviceProperties
  {
    wxString m_strScsiDevice;
    wxString m_strDeviceType;
    wxString m_strVendor;
    wxString m_strID;
    bool     m_bReadsCDR;
    bool     m_bReadsCDRW;
    bool     m_bWritesCDR;
    bool     m_bWritesCDRW;
    bool     m_bReadsDVDROM;
    bool     m_bReadsDVDR;
    bool     m_bReadsDVDRAM;
    bool     m_bWritesDVDR;
    bool     m_bWritesDVDRAM;
    bool     m_bSupportsTestWriting;
    bool     m_bSupportsMultiSession;
  };

  WX_DECLARE_STRING_HASH_MAP(BurnHelpers::DeviceProperties, /*BurnHelpers::*/BurnDeviceMap);
  //typedef std::map<wxString, BurnHelpers::DeviceProperties> /*BurnHelpers::*/BurnDeviceMap;

  // This difference between this use of wxProcess versus the one in BurnProgressDlg is that
  //  This one is meant to not return any information until the process is done.
  //  BurnProgressDlg is meant the return progress information to derived classes as each line of
  //  output is done
  wxArrayString RunCommandCaptureOutput(const wxString& strCmd, bool bUseStdError = FALSE);
  wxArrayString GetAvailableDevices();
  BurnHelpers::BurnDeviceMap GetAvailableDevicesMap();
  BurnHelpers::DeviceProperties GetDeviceProperties(const wxString& strDevice);
  void PopulateCDCombo(BurnHelpers::BurnDeviceMap* pDeviceMap, wxComboBox* pCombo, bool bWritersOnly = TRUE);
  wxString GetDeviceFromComboString(const wxString& strComboString);
  wxString GetBinFileName(const wxString& strFileName);
  wxString GetCueFileName(const wxString& strFileName);
  void PopulateCdrecordDeviceTypeCombo(wxComboBox* pCombo);
  void PopulateCdrdaoDeviceTypeCombo(wxComboBox* pCombo);
  void PopulateBurnSpeedCombo(wxComboBox* pCombo);
};



#endif
