/////////////////////////////////////////////////////////////////////////////
// Name:        CDCopyDialog.h
// Author:      XX
// Created:     XX/XX/XX
// Copyright:   XX
/////////////////////////////////////////////////////////////////////////////

#ifndef __CDCopyDialog_H__
#define __CDCopyDialog_H__

#ifdef __GNUG__
    #pragma interface "CDCopyDialog.cpp"
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

//#include <wx/dialog.h>
//#include <wx/hashmap.h>
#include "wxBurn_wdr.h"
//#include "BurnHelpers.h"
#include "BurnOptions.h"


//----------------------------------------------------------------------------
// CopyCDOptions
//----------------------------------------------------------------------------

class CCopyCDOptions : public BurnOptions
{
public:
  CCopyCDOptions();

  wxString GetSrcDevice() { return m_strSrcDevice; }
  wxString* GetSrcDevicePtr() { return &m_strSrcDevice; }
  void SetSrcDevice(const wxString& strSrcDevice) { m_strSrcDevice = strSrcDevice; }
  wxString GetSrcDriver() { return m_strSrcDriver; }
  wxString* GetSrcDriverPtr() { return &m_strSrcDriver; }
  void SetSrcDriver(const wxString& strSrcDriver) { m_strSrcDriver = strSrcDriver; }
  wxString GetBurnDriver() { return m_strBurnDriver; }
  wxString* GetBurnDriverPtr() { return &m_strBurnDriver; }
  void SetBurnDriver(const wxString& strBurnDriver) { m_strBurnDriver = strBurnDriver; }
  int GetFifoBuffer() { return m_nFifoBuffer; }
  int* GetFifoBufferPtr() { return &m_nFifoBuffer; }
  void SetFifoBuffer(int nFifoBuffer) { m_nFifoBuffer = nFifoBuffer; }
  bool GetKeepImages() { return m_bKeepImages; }
  bool* GetKeepImagesPtr() { return &m_bKeepImages; }
  void SetKeepImages(bool bKeepImages) { m_bKeepImages = bKeepImages; }
  wxString GetCueFile() { return m_strCueFile; }
  wxString* GetCueFilePtr() { return &m_strCueFile; }
  void SetCueFile(const wxString& strCueFile) { m_strCueFile = strCueFile; }

protected:
  wxString  m_strSrcDevice;
  wxString  m_strSrcDriver;
  wxString  m_strBurnDriver;
  int       m_nFifoBuffer;
  bool      m_bKeepImages;
  wxString  m_strCueFile;
};

// WDR: class declarations

//----------------------------------------------------------------------------
// CCopyCDOptionsDialog
//----------------------------------------------------------------------------

class CCopyCDOptionsDialog: public wxDialog
{
public:
  // constructors and destructors
  CCopyCDOptionsDialog( wxWindow *parent, wxWindowID id, const wxString &title,
    CCopyCDOptions* pOptions,// BurnDeviceMap* pDeviceMap,
    const wxPoint& pos = wxDefaultPosition,
    const wxSize& size = wxDefaultSize,
    long style = wxDEFAULT_DIALOG_STYLE );
  
  // WDR: method declarations for CCopyCDOptionsDialog
    
private:
  // WDR: member variable declarations for CCopyCDOptionsDialog
  CCopyCDOptions* m_pOptions;
  //BurnDeviceMap*   m_pDeviceMap;

private:
  // WDR: handler declarations for CCopyCDOptionsDialog
    void OnOK( wxCommandEvent &event );
  void OnChangeKeepImagesCheckbox(wxCommandEvent &event);
  void OnCopyCDImageFileBrowse(wxCommandEvent &event);
  void OnCopyCDCueFileBrowse(wxCommandEvent &event);

private:
  DECLARE_EVENT_TABLE()
};

//----------------------------------------------------------------------------
// CCopyCDDialog
//----------------------------------------------------------------------------

class CCopyCDDialog: public wxDialog
{
public:
  // constructors and destructors
  CCopyCDDialog( wxWindow *parent, wxWindowID id, const wxString &title,
    //BurnDeviceMap* pDeviceMap,
    const wxPoint& pos = wxDefaultPosition,
    const wxSize& size = wxDefaultSize,
    long style = wxDEFAULT_DIALOG_STYLE );

  // WDR: method declarations for CCopyCDDialog
  CCopyCDOptions* GetOptions() { return &m_CopyCDOptions; }

private:
  // WDR: member variable declarations for CCopyCDDialog
  CCopyCDOptions m_CopyCDOptions;
  //BurnDeviceMap*   m_pDeviceMap;

    
private:
  void PopulateComboBoxes();

  // WDR: handler declarations for CCopyCDDialog
    void OnOK( wxCommandEvent &event );
  void OnCopyCDOptions(wxCommandEvent &event);

private:
  DECLARE_EVENT_TABLE()
};




#endif
