/////////////////////////////////////////////////////////////////////////////
// Name:        wxBurn.cpp
// Author:      XX
// Created:     XX/XX/XX
// Copyright:   
/////////////////////////////////////////////////////////////////////////////

#ifdef __GNUG__
    #pragma implementation "wxBurn.h"
#endif

// For compilers that support precompilation
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

// Include private headers
#include "wxBurn.h"
#include "wxBurnDnD.h"
#include "BurnProgressDlg.h"
#include "CDCopyDialog.h"

//#include <sys/types.h>
//#include <sys/stat.h>

//#include <wx/filefn.h>
#include <wx/dirctrl.h>
#include <wx/filename.h>
#include <wx/valgen.h>

// ----------------------------------------------------------------------------
// resources
// ----------------------------------------------------------------------------

// the application icon (under Windows and OS/2 it is in resources)
#if defined(__WXGTK__) || defined(__WXMOTIF__) || defined(__WXMAC__) || defined(__WXMGL__) || defined(__WXX11__)
    #include "mondrian.xpm"
#endif

#ifdef __WXMSW__
  #include <io.h>

    #define S_IRUSR 04
    #define S_IRGRP 04
    #define S_IROTH 04

    #define S_IWUSR 02
    #define S_IWGRP 02
    #define S_IWOTH 02

    #define S_IXUSR 06
    #define S_IXGRP 06
    #define S_IXOTH 06
#endif



// WDR: class implementations

//------------------------------------------------------------------------------
// BurnerFrame
//------------------------------------------------------------------------------

// WDR: event table for BurnerFrame

BEGIN_EVENT_TABLE(BurnerFrame,wxFrame)
        // Menu handlers
    EVT_MENU(ID_ABOUT, BurnerFrame::OnAbout)
    EVT_MENU(ID_QUIT, BurnerFrame::OnQuit)
    EVT_MENU(ID_OPTIONS_DATA_CD, BurnerFrame::OnEditOptionsDataCD)
    EVT_MENU(ID_OPTIONS_AUDIO_CD, BurnerFrame::OnEditOptionsAudioCD)
    EVT_MENU(ID_OPTIONS_VIDEO_CD, BurnerFrame::OnEditOptionsVideoCD)
    EVT_MENU(ID_VIEW_LAYOUT, BurnerFrame::OnViewLayoutMap)
    EVT_MENU(ID_VIEW_PREVIEW_MKISOFS_CMDLINE, BurnerFrame::OnViewPreviewMkisofsCmdLine)
    EVT_MENU(ID_VIEW_PREVIEW_CDRECORD_CMDLINE, BurnerFrame::OnViewPreviewCdrecordCmdLine)
    EVT_MENU(ID_FILE_NEW, BurnerFrame::OnFileNew)
    EVT_MENU(ID_FILE_OPEN, BurnerFrame::OnFileOpen)
    EVT_MENU(ID_SAVE_LAYOUT, BurnerFrame::OnSaveLayout)
    EVT_MENU(ID_SAVE_OPTIONS, BurnerFrame::OnSaveOptions)
    EVT_MENU(ID_MAKE_ISO, BurnerFrame::OnMakeISO)
    EVT_MENU(ID_BURN_ISO_IMAGE, BurnerFrame::OnBurnISO)
    EVT_MENU(ID_MAKE_BIN, BurnerFrame::OnMakeBin)
    EVT_MENU(ID_BURN_CUE_BIN_IMAGE, BurnerFrame::OnBurnBin)
    EVT_MENU(ID_BURN_CD, BurnerFrame::OnBurnCD)
    EVT_MENU(ID_COPY_CD, BurnerFrame::OnCopyCD)

    EVT_CLOSE(BurnerFrame::OnCloseWindow)
        
    //EVT_LEFT_DOWN(BurnerFrame::OnLeftDown)
        
        // Source wxTreeCtrl handlers
    EVT_TREE_BEGIN_LABEL_EDIT(ID_TREE_CD_DIR, BurnerFrame::OnBeginCDLayoutTreeLabelEdit)
    EVT_TREE_SEL_CHANGED( ID_TREE_CD_DIR, BurnerFrame::CDDirChange )
    EVT_TREE_ITEM_RIGHT_CLICK(ID_TREE_CD_DIR, BurnerFrame::OnLayoutItemRightClick)
//    EVT_TREE_DELETE_ITEM(ID_TREE_CD_DIR, BurnerFrame::OnLayoutItemDelete)
    EVT_MENU(ID_MENU_RENAME_DIR, BurnerFrame::OnRename)
    EVT_MENU(ID_MENU_CREATE_DIR, BurnerFrame::OnCreateDirectory)
    EVT_MENU(ID_MENU_DELETE_DIR, BurnerFrame::OnDelete)
    EVT_MENU(ID_MENU_ENTER_LAYOUT_DIR, BurnerFrame::EnterLayoutListItemDir)
        
        // Source wxListCtrl handlers
    EVT_LIST_ITEM_ACTIVATED(ID_LIST_AVAIL_FILES, BurnerFrame::OnSelectAvailListItem)
    EVT_LIST_ITEM_RIGHT_CLICK(ID_LIST_AVAIL_FILES, BurnerFrame::OnAvailListRightClick)
    EVT_LIST_ITEM_RIGHT_CLICK(ID_LIST_CD_FILES, BurnerFrame::OnCDLayoutListRightClick)
    EVT_LIST_BEGIN_DRAG(ID_LIST_AVAIL_FILES, BurnerFrame::OnDragAvailList)
    
    EVT_MENU(ID_MENU_ADD_TREE_ITEM_TO_LAYOUT, BurnerFrame::OnAddAvailTreeItemToLayout)
    EVT_MENU(ID_MENU_ADD_LIST_ITEM_TO_LAYOUT, BurnerFrame::OnAddAvailListItemToLayout)
    EVT_MENU(ID_MENU_ENTER_DIR, BurnerFrame::EnterListItemDir)
END_EVENT_TABLE()

void BurnerFrame::OnLeftDown(wxMouseEvent &WXUNUSED(event) )
{
  // start drag operation
  //wxFileDataObject FileData;

  wxDropSource source;
}

void BurnerFrame::OnLayoutItemRightClick(wxTreeEvent& event)
{
  CDLayoutTreeCtrl* pTree = GetCDLayoutTree();
  if (pTree)
  {
    pTree->SelectItemFromHitTest(event.GetPoint());
    ShowMenu(event.GetItem(), event.GetPoint());
   }
}

void BurnerFrame::ShowMenu(wxTreeItemId id, const wxPoint& pt)
{
  wxTreeCtrl* pTree = GetCDLayoutTree();
  if (pTree)
  {
    wxMenu menu;
    menu.Append(ID_MENU_CREATE_DIR, "Create Child Directory");
    menu.Append(ID_MENU_RENAME_DIR, "Rename Directory");
    menu.Append(ID_MENU_DELETE_DIR, "Delete Directory");
    
    // Don't allow the root to be renamed or deleted
    menu.Enable(ID_MENU_RENAME_DIR, (pTree->GetRootItem() != id));
    menu.Enable(ID_MENU_DELETE_DIR, (pTree->GetRootItem() != id));

    pTree->PopupMenu(&menu, pt);
  }
}

void BurnerFrame::OnRename(wxCommandEvent& WXUNUSED(event))
{
  CDLayoutTreeCtrl* pTree = GetCDLayoutTree();
  if (pTree)
  {
    pTree->RenameTreeDirectory();
  }
/*  
  wxTreeItemId item = pTree->GetSelection();
  pTree->EditLabel(item);
  
  // The following functionality may go in the EVT_TREE_END_LABEL_EDIT handler
  // Checking should be done to insure that duplicate folder names are not accepted.  I'm not sure
  //  how to deal with case sensitive checking versus Joliet/Rockridge images
  // If the label was changed then we have to update the m_CDLayoutMap.
  //  This may mean that we need to have the changed directory ignored in it's directory heirarchy
  //  and have a new item in the map added to custom add this to the layout
  //  Also any items in the map that were below this item must be changed to reflect this change.
  //  On the bright side, since we're only adding "customizations" to the m_CDLayoutMap,
  //  This won't be a huge amount of work (hopefully)
*/
}

void BurnerFrame::OnCreateDirectory(wxCommandEvent& WXUNUSED(event))
{
  CDLayoutTreeCtrl* pTree = GetCDLayoutTree();
  if (pTree)
  {
    pTree->CreateTreeDirectory();
  }
/*  
  wxTreeItemId item = pTree->GetSelection();
  wxTreeItemId NewItem = pTree->AppendItem(item, "New Directory", 0, 1);
  pTree->Expand(item);
  pTree->SelectItem(NewItem);
  pTree->EditLabel(NewItem);

  // This may not change the m_CDLayoutMap at all.  A side effect to not adding it to the map unless
  //  Files/Directories are added to the new directory is that it won't be added to the CD image
  //  Since it would be empty anyway, I'm okay with this (for now).
*/
}
void BurnerFrame::OnDelete(wxCommandEvent& WXUNUSED(event))
{
  CDLayoutTreeCtrl* pTree = GetCDLayoutTree();
    if (pTree)
    {
        pTree->DeleteTreeDirectory();
    }
/*  
  wxTreeItemId item = pTree->GetSelection();
  pTree->Delete(item);

  // The following functionality may go in the EVT_TREE_DELETE_ITEM handler
  // If this event is in m_CDLayoutMap, then remove the entry
  // If this event is a subdirectory of an item in m_CDLayoutMap, then another entry must
  //  be made to m_CDLayoutMap excluding this directory from the layout
  // We might want to add an item to the popup menu for "Restore Deleted Directories" which
  //  would let the user readd this directory since it still exists on the hard drive
*/}

void BurnerFrame::OnAvailTreeRightClick(wxTreeEvent& event)
{
  wxGenericDirCtrl* pDirCtrl = GetAvailFilesTree();
  if (pDirCtrl)
  {
    wxTreeItemId item = event.GetItem();
    if (item.IsOk())
      GetAvailFilesTree()->GetTreeCtrl()->SelectItem(item);
    wxMenu menu;
    menu.Append(ID_MENU_ADD_TREE_ITEM_TO_LAYOUT, "Add Directory to CD Layout");
    pDirCtrl->PopupMenu(&menu, event.GetPoint());
  }
}

void BurnerFrame::OnAddAvailTreeItemToLayout(wxCommandEvent& WXUNUSED(event))
{
  wxGenericDirCtrl* pDirCtrl = GetAvailFilesTree();
  if (pDirCtrl)
  {
    wxString strPath = pDirCtrl->GetPath();
    GetCDLayoutTree()->AddToCDLayout(strPath, GetCDLayoutList());
  }
}

void BurnerFrame::OnAddAvailListItemToLayout(wxCommandEvent& WXUNUSED(event))
{
  wxListCtrl* pListCtrl = GetAvailFilesList();
  wxGenericDirCtrl* pDirCtrl = GetAvailFilesTree();
  if (pDirCtrl && pListCtrl)
  {
    long nItem = -1;
    nItem = pListCtrl->GetNextItem(nItem, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED);
    if (nItem != -1)
    {
      wxString strListEntry = pListCtrl->GetItemText(nItem);
      wxString strPath = pDirCtrl->GetPath() + wxFileName::GetPathSeparator() + strListEntry;
      GetCDLayoutTree()->AddToCDLayout(strPath, GetCDLayoutList());
    }
  }
}

void BurnerFrame::OnAvailListRightClick(wxListEvent& event)
{
  wxListCtrl* pListCtrl = GetAvailFilesList();
  wxGenericDirCtrl* pDirCtrl = GetAvailFilesTree();
  if (pDirCtrl && pListCtrl)
  {
    // Select the list item that was clicked on (if any)
    int nIndex = event.GetIndex();
    wxString strText = pListCtrl->GetItemText(nIndex);
    wxString strDir = pDirCtrl->GetPath();
    strDir += wxFileName::GetPathSeparator() + strText;

    pListCtrl->SetItemState(nIndex, wxLIST_STATE_SELECTED | wxLIST_STATE_FOCUSED, wxLIST_STATE_SELECTED);
    wxMenu menu;
    if (wxFileName::DirExists(strDir))
    {
      menu.Append(ID_MENU_ENTER_DIR, "Select Directory");
      menu.Append(ID_MENU_ADD_LIST_ITEM_TO_LAYOUT, "Add Directory to CD Layout");
    }
    else
    {
      menu.Append(ID_MENU_ADD_LIST_ITEM_TO_LAYOUT, "Add File to CD Layout");
    }
    
    pListCtrl->PopupMenu(&menu, event.GetPoint());
  }
}

void BurnerFrame::EnterListItemDir(wxCommandEvent& WXUNUSED(event))
{
  wxListCtrl* pListCtrl = GetAvailFilesList();
  wxGenericDirCtrl* pDirCtrl = GetAvailFilesTree();
  if (pDirCtrl)
  {
    long nItem = -1;
    nItem = pListCtrl->GetNextItem(nItem, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED);
    if (nItem != -1)
    {
      wxString strListEntry = pListCtrl->GetItemText(nItem);
      wxString strPath = pDirCtrl->GetPath() + wxFileName::GetPathSeparator() + strListEntry;
      if (wxFileName::DirExists(strPath))
      {
        pDirCtrl->SetPath(strPath);
      }
    }
  }
}

void BurnerFrame::EnterLayoutListItemDir(wxCommandEvent& WXUNUSED(event))
{
}

void BurnerFrame::OnCDLayoutListRightClick(wxListEvent& event)
{
  wxListCtrl* pListCtrl = GetCDLayoutList();
  CDLayoutTreeCtrl* pTreeCtrl = GetCDLayoutTree();
  if (pListCtrl)
  {
    // Select the list item that was clicked on (if any)
    int nIndex = event.GetIndex();
    wxString strText = pListCtrl->GetItemText(nIndex);
    wxString strDir = pTreeCtrl->GetCurrentCDLayoutTreePath();
    strDir += /*wxFileName::GetPathSeparator() + */strText;
    strDir = pTreeCtrl->GetOrigin(strDir);

    pListCtrl->SetItemState(nIndex, wxLIST_STATE_SELECTED | wxLIST_STATE_FOCUSED, wxLIST_STATE_SELECTED);
    wxMenu menu;
    if (wxFileName::DirExists(strDir))
    {
      menu.Append(ID_MENU_ENTER_LAYOUT_DIR, "Select Directory");
      menu.Append(ID_MENU_REMOVE_FROM_LAYOUT, "Remove Directory from CD Layout");
    }
    else
    {
      menu.Append(ID_MENU_REMOVE_FROM_LAYOUT, "Remove File from CD Layout");
    }
    
    pListCtrl->PopupMenu(&menu, event.GetPoint());
  }
}

void BurnerFrame::OnDragAvailList(wxListEvent& event)
{
  // Unfortunately, wxFileDataObjects can't be created from wxWindows on non-Win32 platforms
  //  so this code will only allow dragging from the top wxListCtrl on Win32
  wxFileDataObject my_data;
  wxString strDir = GetAvailFilesTree()->GetPath();
  long nFileIndex = event.GetIndex();
  wxString strFile = GetAvailFilesList()->GetItemText(nFileIndex);
  wxString strPath = /*"file:" + */strDir + wxFileName::GetPathSeparator() + strFile/* + "\r\n"*/;
  my_data.AddFile(strPath);
  //my_data.SetData(0, strPath.c_str());
    wxDropSource dragSource( this );
    dragSource.SetData( my_data );
    dragSource.DoDragDrop( TRUE );
}

void BurnerFrame::OnDragAvailTree(wxTreeEvent& event)
{
  // Unfortunately, wxFileDataObjects can't be created from wxWindows on non-Win32 platforms
  //  so this code will only allow dragging from the top wxListCtrl on Win32
  wxFileDataObject my_data;
  wxTreeItemId item = event.GetItem();
  if (item.IsOk())
    GetAvailFilesTree()->GetTreeCtrl()->SelectItem(item);
  wxString strPath = GetAvailFilesTree()->GetPath();
  my_data.AddFile(strPath);
    wxDropSource dragSource( this );
    dragSource.SetData( my_data );
    dragSource.DoDragDrop( TRUE );
}

BurnerFrame::BurnerFrame( wxWindow *parent, wxWindowID id, const wxString &title,
    const wxPoint &position, const wxSize& size, long style ) :
    wxFrame( parent, id, title, position, size, style )
{
    ::wxInitAllImageHandlers();

    m_pImageList = new wxImageList(16, 15, TRUE, 2);
    m_pImageList->Add(FileListCtrlImages(0));  // Directory icon
    m_pImageList->Add(FileListCtrlImages(1));  // File icon

        m_pLayoutImageList = new wxImageList(16, 15, TRUE, 2);
    m_pLayoutImageList->Add(LayoutTreeImages(0));  // Directory icon
    m_pLayoutImageList->Add(LayoutTreeImages(1));  // File icon
        
    SetIcon( wxICON(mondrian) );

    CreateMyMenuBar();
    
    CreateMyToolBar();
    
    CreateStatusBar(1);
    SetStatusText( wxT("Welcome!") );
    
     // insert main window here
    MainFormFunction(this);
    wxSplitterWindow* pMainSplitter = GetSplitterDatacd();//new wxSplitterWindow(GetNotebook());

    wxPanel *pTopPanel = new wxPanel(pMainSplitter, -1);
    TopHalfWindow(pTopPanel);
    wxGenericDirCtrl* pDirCtrl = new wxGenericDirCtrl(GetTopSplitterWindow(), ID_TREE_AVAIL_DIR,
         ::wxGetHomeDir(), wxDefaultPosition, wxDefaultSize, wxDIRCTRL_3D_INTERNAL | wxDIRCTRL_DIR_ONLY);
    wxListCtrl* pFileSystemListCtrl = new wxListCtrl(GetTopSplitterWindow(), ID_LIST_AVAIL_FILES, wxDefaultPosition, wxDefaultSize, wxLC_REPORT | wxLC_SINGLE_SEL);
    GetTopSplitterWindow()->SplitVertically(pDirCtrl, pFileSystemListCtrl, 200);
    
    wxPanel *pBottomPanel = new wxPanel(pMainSplitter, -1);
    BottomHalfWindow(pBottomPanel);
    CDLayoutTreeCtrl* pTreeCtrl = new CDLayoutTreeCtrl(GetBottomSplitterWindow(), ID_TREE_CD_DIR, wxDefaultPosition, wxDefaultSize, wxTR_HAS_BUTTONS | wxTR_EDIT_LABELS);
    wxListCtrl* pCDListCtrl = new wxListCtrl(GetBottomSplitterWindow(), ID_LIST_CD_FILES, wxDefaultPosition, wxDefaultSize, wxLC_REPORT);
    GetBottomSplitterWindow()->SplitVertically(pTreeCtrl, pCDListCtrl, 200);
    
    pMainSplitter->SplitHorizontally(pTopPanel, pBottomPanel);

    // Connect the wxGenericDirCtrl
    Connect(pDirCtrl->GetTreeCtrl()->GetId(), wxEVT_COMMAND_TREE_SEL_CHANGED, (wxObjectEventFunction) (wxEventFunction) (wxCommandEventFunction) &BurnerFrame::AvailableFilesDirChange);
    Connect(pDirCtrl->GetTreeCtrl()->GetId(), wxEVT_COMMAND_TREE_BEGIN_DRAG, (wxObjectEventFunction) (wxEventFunction) (wxCommandEventFunction) &BurnerFrame::OnDragAvailTree);
    Connect(pDirCtrl->GetTreeCtrl()->GetId(), wxEVT_COMMAND_TREE_ITEM_RIGHT_CLICK, (wxObjectEventFunction) (wxEventFunction) (wxCommandEventFunction) &BurnerFrame::OnAvailTreeRightClick);

    // Set up the list controls
    InitializeListControls();

    GetCDLayoutTree()->SetImageList(m_pLayoutImageList);
    // associate drop targets with the tree control
    GetCDLayoutTree()->SetDropTarget(new TreeDnDFile(GetCDLayoutTree(), GetCDLayoutList()));

    // Add a root item to the CD Layout tree control
    GetCDLayoutTree()->Clear();
    GetCDLayoutList()->DeleteAllItems();

    // Associate the MB used static text with live data
    //FindWindow(ID_TEXT_CD_CURRENT)->SetValidator(wxGenericValidator(GetCDLayoutTree()->GetTotalSizeInMBPtr()));

    // Test values
    GetGaugeDatacd()->SetRange(650);

    m_DeviceMap = BurnHelpers::GetAvailableDevicesMap();
}

BurnerFrame::~BurnerFrame()
{
  if (m_pImageList)
  {
    delete m_pImageList;
    m_pImageList = NULL;
  }
  if (m_pLayoutImageList)
  {
    delete m_pLayoutImageList;
    m_pLayoutImageList = NULL;
  }
}

void BurnerFrame::CreateMyMenuBar()
{
#ifdef __WXMAC__
    wxApp::s_macAboutMenuItemId = ID_ABOUT;
#endif

    SetMenuBar( MyMenuBarFunc() );
}

void BurnerFrame::CreateMyToolBar()
{
    wxToolBar *tb = CreateToolBar( wxTB_HORIZONTAL|wxNO_BORDER /* |wxTB_FLAT */ );
    
    MyToolBarFunc( tb );
}

void BurnerFrame::InitializeListControls()
{
  wxListCtrl* pListCtrl = GetAvailFilesList();
  if (pListCtrl)
  {
    pListCtrl->InsertColumn(0, "Name");
    pListCtrl->InsertColumn(1, "Size", wxLIST_FORMAT_RIGHT);
    pListCtrl->InsertColumn(2, "Date");
    pListCtrl->InsertColumn(3, "Permissions");
    
    pListCtrl->SetImageList(m_pImageList, wxIMAGE_LIST_SMALL);
  }
  pListCtrl = GetCDLayoutList();
  if (pListCtrl)
  {
    pListCtrl->InsertColumn(0, "Name");
    pListCtrl->InsertColumn(1, "Size", wxLIST_FORMAT_RIGHT);
    pListCtrl->InsertColumn(2, "Origin");
    
    pListCtrl->SetImageList(m_pImageList, wxIMAGE_LIST_SMALL);

    // associate drop targets with the controls
    pListCtrl->SetDropTarget(new ListDnDFile(GetCDLayoutTree(), pListCtrl));
  }

}

// WDR: handler implementations for BurnerFrame

void BurnerFrame::OnEditOptionsDataCD( wxCommandEvent &event )
{
  CDataDefaultOptionsDlg OptionsDlg(this, -1, "Default Data CD Options", &m_DefaultDataOptions, wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER);
  OptionsDlg.PopulateCombo(&m_DeviceMap);
  OptionsDlg.Centre();  
  OptionsDlg.ShowModal();
}

void BurnerFrame::OnEditOptionsAudioCD( wxCommandEvent &event )
{
}

void BurnerFrame::OnEditOptionsVideoCD( wxCommandEvent &event )
{
}

void BurnerFrame::OnViewLayoutMap( wxCommandEvent &event )
{
    GetCDLayoutTree()->DisplayLayoutMap();
}

void BurnerFrame::OnViewPreviewMkisofsCmdLine( wxCommandEvent &event )
{
  DataBurnProgressDlg dlg(this, -1, "Burn Feedback", wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER);
  dlg.SetMode(BurnProgressDlg::CREATE_IMAGE);
  dlg.SetBurnOptions(&m_DefaultDataOptions);
  dlg.SetLayoutMaps(GetCDLayoutMap(), GetCDLayoutExcludeMap());
  ::wxMessageBox(dlg.GenerateCmdLine());
}

void BurnerFrame::OnViewPreviewCdrecordCmdLine( wxCommandEvent &event )
{
  DataBurnProgressDlg dlg(this, -1, "Burn Feedback", wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER);
  dlg.SetMode(BurnProgressDlg::BURN_IMAGE);
  dlg.SetBurnOptions(&m_DefaultDataOptions);
  //dlg.SetLayoutMaps(GetCDLayoutMap(), GetCDLayoutExcludeMap());
  ::wxMessageBox(dlg.GenerateCmdLine());
}

void BurnerFrame::AvailableFilesDirChange( wxTreeEvent &event )
{
  wxGenericDirCtrl* pDirCtrl = GetAvailFilesTree();
  wxListCtrl* pListCtrl = GetAvailFilesList();
  if (pDirCtrl && pListCtrl)
  {
    pListCtrl->DeleteAllItems();
    wxDir dir;
    dir.Open(pDirCtrl->GetPath());
    BurnerAvailFilesTraverser DirTraverse(pListCtrl);
    dir.Traverse(DirTraverse);
    if (pListCtrl->GetItemCount() > 0)
    {
      pListCtrl->SetColumnWidth(0, wxLIST_AUTOSIZE);
      //pListCtrl->SetColumnWidth(1, wxLIST_AUTOSIZE);
      pListCtrl->SetColumnWidth(2, wxLIST_AUTOSIZE | wxLIST_AUTOSIZE_USEHEADER);
    }
  }
}

void BurnerFrame::OnSelectAvailListItem( wxListEvent &event )
{
  wxGenericDirCtrl* pDirCtrl = GetAvailFilesTree();
  if (pDirCtrl)
  {
    wxString strPath = pDirCtrl->GetPath() + wxFileName::GetPathSeparator() + event.GetText();
    if (wxFileName::DirExists(strPath))
    {
      pDirCtrl->SetPath(strPath);
    }
    else if (wxFileName::FileExists(strPath))   // Move the selected files into the currently selected directory of the CD layout
    {
      // Get a pointer to the list control
      // Check for entries already in the class array (described below) with the same "CD file layout position/name"
      // Add the entry as a new instance of a class that saves 
      //    "CD file layout position/name",
      //    "source path", "whether file or directory",
      //    "whether to include or exclude"
      // An array of these classes will be used to populate the tree control which will populate the list control
     // wxString strFilePath = GetCDLayoutTree()->GetCurrentCDLayoutTreePath() + strPath.AfterLast(wxFileName::GetPathSeparator());
     // CDLayoutItem item(strFilePath, strPath, CDLayoutItem::LAYOUT_FILE, TRUE);
     // GetCDLayoutTree()->AddToCDLayout(item, GetCDLayoutList());
      GetCDLayoutTree()->AddToCDLayout(strPath, GetCDLayoutList());
            //SetUsedSpaceProgressBar(GetCDLayoutTree()->GetTotalSize());
    }
  }
}

void BurnerFrame::SetUsedSpaceGauge(long nNewFileSize)
{
    GetGaugeDatacd()->SetValue(nNewFileSize);
}

void BurnerFrame::SetUsedSpaceProgressBar(const wxString& strNewFileSize)
{
    ((wxStaticText*)FindWindow(ID_TEXT_CD_CURRENT))->SetLabel(strNewFileSize);
}

void BurnerFrame::CDDirChange( wxTreeEvent &event )
{
    // Clear out the CD layout wxListCtrl
    // Get the CD layout directory from the wxGenericDirCtrl
    // Loop through the keys of the m_CDLayoutMap
    // ONLY CHECK m_CDLayoutMap entries marked as INCLUDE
    // Find the closest match ("/data/CD1/test" is closer to "/data/CD1/test/sub/dir" than "/data/CD1" is)
    // Append the difference between the matching map key and the actual CD layout directory
    // Have the CDLayout wxListCtrl populate itself from the matching map key + appended difference
    // The above will populate the wxListCtrl from the actual source directory structure
    // Now we have to get any additional entries listed in the m_CDLayoutMap
    // and remove any of those entries listed as EXCLUDE
    CDLayoutTreeCtrl* pLayoutTree = GetCDLayoutTree();
    wxListCtrl* pLayoutList = GetCDLayoutList();
    if (pLayoutTree && pLayoutList)
    {
        pLayoutTree->ChangeCDLayoutDir(pLayoutList);
    }
}

void BurnerFrame::OnBeginCDLayoutTreeLabelEdit( wxTreeEvent &event )
{
    CDLayoutTreeCtrl* pLayoutTree = GetCDLayoutTree();
    if (!(pLayoutTree->TreeItemIsEditable(pLayoutTree->GetSelection())))
      event.Veto();
}

void BurnerFrame::OnAbout( wxCommandEvent &event )
{
    wxMessageDialog dialog( this, wxT("Welcome to wxBurn\nA frontend to cdrtools\n(http://www.fokus.fhg.de/research/cc/glone/employees/joerg.schilling/private/cdrecord.html)"),
        wxT("About wxBurn"), wxOK|wxICON_INFORMATION );
    dialog.Centre();
    dialog.ShowModal();
}

void BurnerFrame::OnQuit( wxCommandEvent &event )
{
     Close( TRUE );
}

void BurnerFrame::OnCloseWindow( wxCloseEvent &event )
{
    // if ! saved changes -> return
    
    Destroy();
}

void BurnerFrame::OnFileNew( wxCommandEvent &event )
{
  GetCDLayoutTree()->Clear();
  GetCDLayoutList()->DeleteAllItems();
  SetUsedSpaceProgressBar("0");
  SetUsedSpaceGauge(0);
}

void BurnerFrame::OnFileOpen( wxCommandEvent &event )
{
}

void BurnerFrame::OnSaveLayout( wxCommandEvent &event )
{
}

void BurnerFrame::OnSaveOptions( wxCommandEvent &event )
{
}

void BurnerFrame::OnMakeISO(wxCommandEvent &event)
{
  OptionsDataCD Options = m_DefaultDataOptions; // Make a local options instance so that the defaults don't get overwritten
  CMakeIsoOptionsDlg IsoOptionsDlg(this, -1, "ISO Options", &Options, wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER);
  IsoOptionsDlg.Centre();
  if (wxID_OK == IsoOptionsDlg.ShowModal())
  {
      DataBurnProgressDlg dlg(this, -1, "Burn Feedback", wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER);
      dlg.SetBurnOptions(&Options);
      dlg.SetLayoutMaps(GetCDLayoutMap(), GetCDLayoutExcludeMap());
      dlg.CreateISOImage();
  }
}

void BurnerFrame::OnBurnISO(wxCommandEvent &event)
{
  OptionsDataCD Options = m_DefaultDataOptions; // Make a local options instance so that the defaults don't get overwritten
  CDataBurnOptionsDlg BurnOptionsDlg(this, -1, "Burn Options", &Options, wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER);
  BurnOptionsDlg.PopulateCombo(&m_DeviceMap);
  BurnOptionsDlg.Centre();
  if (wxID_OK == BurnOptionsDlg.ShowModal())
  {
      DataBurnProgressDlg dlg(this, -1, "Burn Feedback", wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER);
      dlg.SetBurnOptions(&Options);
      dlg.SetLayoutMaps(GetCDLayoutMap(), GetCDLayoutExcludeMap());
      dlg.BurnISOImage();
  }
}

void BurnerFrame::OnMakeBin(wxCommandEvent &event)
{
}

void BurnerFrame::OnBurnBin(wxCommandEvent &event)
{
}

void BurnerFrame::OnBurnCD(wxCommandEvent &event)
{
  OptionsDataCD Options = m_DefaultDataOptions; // Make a local options instance so that the defaults don't get overwritten
  CDataOptionsDlg OptionsDlg(this, -1, "Default Data CD Options", &Options, wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER);
  OptionsDlg.PopulateCombo(&m_DeviceMap);
  OptionsDlg.Centre();  
  if (wxID_OK == OptionsDlg.ShowModal())
  {
      DataBurnProgressDlg dlg(this, -1, "Burn Feedback", wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER);
      dlg.SetBurnOptions(&Options);
      dlg.SetLayoutMaps(GetCDLayoutMap(), GetCDLayoutExcludeMap());
      dlg.BurnCDLayout();
  }
}

void BurnerFrame::OnCopyCD( wxCommandEvent &event )
{
  CCopyCDDialog CDCopyDlg(this, -1,"Copy CD", wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER);
  CDCopyDlg.Centre();
  if (wxID_OK == CDCopyDlg.ShowModal())
  {
    CDCopyProgressDlg FeedbackDlg(this, -1, "Copy CD");
    FeedbackDlg.SetBurnOptions(CDCopyDlg.GetOptions());
    FeedbackDlg.CopyCD();
  }
}

//------------------------------------------------------------------------------
// BurnerApp
//------------------------------------------------------------------------------

IMPLEMENT_APP(BurnerApp)

BurnerApp::BurnerApp()
{
}

bool BurnerApp::OnInit()
{
    BurnerFrame *frame = new BurnerFrame( NULL, -1, wxT("wxBurn"), wxPoint(20,20), wxSize(500,680) );
    frame->Show( TRUE );
    
    return TRUE;
}

int BurnerApp::OnExit()
{
    return 0;
}
